module qrm_mem_mod
  use iso_c_binding
  use qrm_error_mod
  use qrm_const_mod
  use qrm_memhandling_mod
  use qrm_pthread_mod

  interface qrm_move_alloc
    module procedure  qrm_pmove_alloc_1s, qrm_pmove_alloc_2s, qrm_pmove_alloc_3s
    module procedure  qrm_pmove_alloc_1d, qrm_pmove_alloc_2d, qrm_pmove_alloc_3d
    module procedure  qrm_pmove_alloc_1c, qrm_pmove_alloc_2c, qrm_pmove_alloc_3c
    module procedure  qrm_pmove_alloc_1z, qrm_pmove_alloc_2z, qrm_pmove_alloc_3z
    module procedure  qrm_pmove_alloc_1i, qrm_pmove_alloc_2i, qrm_pmove_alloc_3i
    module procedure  qrm_pmove_alloc_1i8, qrm_pmove_alloc_2i8, qrm_pmove_alloc_3i8
    module procedure  qrm_amove_alloc_1s, qrm_amove_alloc_2s, qrm_amove_alloc_3s
    module procedure  qrm_amove_alloc_1d, qrm_amove_alloc_2d, qrm_amove_alloc_3d
    module procedure  qrm_amove_alloc_1c, qrm_amove_alloc_2c, qrm_amove_alloc_3c
    module procedure  qrm_amove_alloc_1z, qrm_amove_alloc_2z, qrm_amove_alloc_3z
    module procedure  qrm_amove_alloc_1i, qrm_amove_alloc_2i, qrm_amove_alloc_3i
    module procedure  qrm_amove_alloc_1i8, qrm_amove_alloc_2i8, qrm_amove_alloc_3i8
  end interface

  interface qrm_dealloc
    module procedure  qrm_pdealloc_1s, qrm_pdealloc_2s, qrm_pdealloc_3s
    module procedure  qrm_pdealloc_1d, qrm_pdealloc_2d, qrm_pdealloc_3d
    module procedure  qrm_pdealloc_1c, qrm_pdealloc_2c, qrm_pdealloc_3c
    module procedure  qrm_pdealloc_1z, qrm_pdealloc_2z, qrm_pdealloc_3z
    module procedure  qrm_pdealloc_1i, qrm_pdealloc_2i, qrm_pdealloc_3i
    module procedure  qrm_pdealloc_1i8, qrm_pdealloc_2i8, qrm_pdealloc_3i8
    module procedure  qrm_adealloc_1s, qrm_adealloc_2s, qrm_adealloc_3s
    module procedure  qrm_adealloc_1d, qrm_adealloc_2d, qrm_adealloc_3d
    module procedure  qrm_adealloc_1c, qrm_adealloc_2c, qrm_adealloc_3c
    module procedure  qrm_adealloc_1z, qrm_adealloc_2z, qrm_adealloc_3z
    module procedure  qrm_adealloc_1i, qrm_adealloc_2i, qrm_adealloc_3i
    module procedure  qrm_adealloc_1i8, qrm_adealloc_2i8, qrm_adealloc_3i8
  end interface

  interface qrm_alloc
    module procedure  qrm_palloc_1s, qrm_palloc_2s, qrm_palloc_3s
    module procedure  qrm_palloc_1d, qrm_palloc_2d, qrm_palloc_3d
    module procedure  qrm_palloc_1c, qrm_palloc_2c, qrm_palloc_3c
    module procedure  qrm_palloc_1z, qrm_palloc_2z, qrm_palloc_3z
    module procedure  qrm_palloc_1i, qrm_palloc_2i, qrm_palloc_3i
    module procedure  qrm_palloc_1i8, qrm_palloc_2i8, qrm_palloc_3i8
    module procedure  qrm_aalloc_1s, qrm_aalloc_2s, qrm_aalloc_3s
    module procedure  qrm_aalloc_1d, qrm_aalloc_2d, qrm_aalloc_3d
    module procedure  qrm_aalloc_1c, qrm_aalloc_2c, qrm_aalloc_3c
    module procedure  qrm_aalloc_1z, qrm_aalloc_2z, qrm_aalloc_3z
    module procedure  qrm_aalloc_1i, qrm_aalloc_2i, qrm_aalloc_3i
    module procedure  qrm_aalloc_1i8, qrm_aalloc_2i8, qrm_aalloc_3i8
  end interface

  interface qrm_realloc
    module procedure  qrm_prealloc_1s
    module procedure  qrm_prealloc_1d
    module procedure  qrm_prealloc_1c
    module procedure  qrm_prealloc_1z
    module procedure  qrm_prealloc_1i
    module procedure  qrm_prealloc_1i8
    module procedure  qrm_arealloc_1s
    module procedure  qrm_arealloc_1d
    module procedure  qrm_arealloc_1c
    module procedure  qrm_arealloc_1z
    module procedure  qrm_arealloc_1i
    module procedure  qrm_arealloc_1i8
  end interface

  interface qrm_size
    module procedure  qrm_psize_1s, qrm_psize_2s, qrm_psize_3s
    module procedure  qrm_psize_1d, qrm_psize_2d, qrm_psize_3d
    module procedure  qrm_psize_1c, qrm_psize_2c, qrm_psize_3c
    module procedure  qrm_psize_1z, qrm_psize_2z, qrm_psize_3z
    module procedure  qrm_psize_1i, qrm_psize_2i, qrm_psize_3i
    module procedure  qrm_psize_1i8, qrm_psize_2i8, qrm_psize_3i8
    module procedure  qrm_asize_1s, qrm_asize_2s, qrm_asize_3s
    module procedure  qrm_asize_1d, qrm_asize_2d, qrm_asize_3d
    module procedure  qrm_asize_1c, qrm_asize_2c, qrm_asize_3c
    module procedure  qrm_asize_1z, qrm_asize_2z, qrm_asize_3z
    module procedure  qrm_asize_1i, qrm_asize_2i, qrm_asize_3i
    module procedure  qrm_asize_1i8, qrm_asize_2i8, qrm_asize_3i8
  end interface



contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                     move_alloc routines                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine qrm_pmove_alloc_1s(src, dst)
  real(kind(1.e0)), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1s

subroutine qrm_pmove_alloc_2s(src, dst)
  real(kind(1.e0)), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2s

subroutine qrm_pmove_alloc_3s(src, dst)
  real(kind(1.e0)), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3s

subroutine qrm_pmove_alloc_1d(src, dst)
  real(kind(1.d0)), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1d

subroutine qrm_pmove_alloc_2d(src, dst)
  real(kind(1.d0)), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2d

subroutine qrm_pmove_alloc_3d(src, dst)
  real(kind(1.d0)), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3d

subroutine qrm_pmove_alloc_1c(src, dst)
  complex(kind(1.e0)), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1c

subroutine qrm_pmove_alloc_2c(src, dst)
  complex(kind(1.e0)), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2c

subroutine qrm_pmove_alloc_3c(src, dst)
  complex(kind(1.e0)), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3c

subroutine qrm_pmove_alloc_1z(src, dst)
  complex(kind(1.d0)), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1z

subroutine qrm_pmove_alloc_2z(src, dst)
  complex(kind(1.d0)), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2z

subroutine qrm_pmove_alloc_3z(src, dst)
  complex(kind(1.d0)), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3z

subroutine qrm_pmove_alloc_1i(src, dst)
  integer(kind=4), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1i

subroutine qrm_pmove_alloc_2i(src, dst)
  integer(kind=4), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2i

subroutine qrm_pmove_alloc_3i(src, dst)
  integer(kind=4), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3i

subroutine qrm_pmove_alloc_1i8(src, dst)
  integer(kind=8), pointer, dimension(:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_1i8

subroutine qrm_pmove_alloc_2i8(src, dst)
  integer(kind=8), pointer, dimension(:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_2i8

subroutine qrm_pmove_alloc_3i8(src, dst)
  integer(kind=8), pointer, dimension(:,:,:) :: src, dst
  dst => src; nullify(src)
  return
end subroutine qrm_pmove_alloc_3i8

subroutine qrm_amove_alloc_1s(src, dst)
  real(kind(1.e0)), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1s

subroutine qrm_amove_alloc_2s(src, dst)
  real(kind(1.e0)), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2s

subroutine qrm_amove_alloc_3s(src, dst)
  real(kind(1.e0)), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3s

subroutine qrm_amove_alloc_1d(src, dst)
  real(kind(1.d0)), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1d

subroutine qrm_amove_alloc_2d(src, dst)
  real(kind(1.d0)), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2d

subroutine qrm_amove_alloc_3d(src, dst)
  real(kind(1.d0)), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3d

subroutine qrm_amove_alloc_1c(src, dst)
  complex(kind(1.e0)), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1c

subroutine qrm_amove_alloc_2c(src, dst)
  complex(kind(1.e0)), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2c

subroutine qrm_amove_alloc_3c(src, dst)
  complex(kind(1.e0)), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3c

subroutine qrm_amove_alloc_1z(src, dst)
  complex(kind(1.d0)), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1z

subroutine qrm_amove_alloc_2z(src, dst)
  complex(kind(1.d0)), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2z

subroutine qrm_amove_alloc_3z(src, dst)
  complex(kind(1.d0)), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3z

subroutine qrm_amove_alloc_1i(src, dst)
  integer(kind=4), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1i

subroutine qrm_amove_alloc_2i(src, dst)
  integer(kind=4), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2i

subroutine qrm_amove_alloc_3i(src, dst)
  integer(kind=4), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3i

subroutine qrm_amove_alloc_1i8(src, dst)
  integer(kind=8), allocatable, dimension(:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_1i8

subroutine qrm_amove_alloc_2i8(src, dst)
  integer(kind=8), allocatable, dimension(:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_2i8

subroutine qrm_amove_alloc_3i8(src, dst)
  integer(kind=8), allocatable, dimension(:,:,:) :: src, dst
  call move_alloc(src, dst)
  return
end subroutine qrm_amove_alloc_3i8

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                     dealloc routines                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine qrm_pdealloc_1s(a, info)

  real(kind(1.e0)), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1s

subroutine qrm_pdealloc_2s(a, info)

  real(kind(1.e0)), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2s

subroutine qrm_pdealloc_3s(a, info)

  real(kind(1.e0)), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3s

subroutine qrm_pdealloc_1d(a, info)

  real(kind(1.d0)), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1d

subroutine qrm_pdealloc_2d(a, info)

  real(kind(1.d0)), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2d

subroutine qrm_pdealloc_3d(a, info)

  real(kind(1.d0)), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3d

subroutine qrm_pdealloc_1c(a, info)

  complex(kind(1.e0)), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1c

subroutine qrm_pdealloc_2c(a, info)

  complex(kind(1.e0)), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2c

subroutine qrm_pdealloc_3c(a, info)

  complex(kind(1.e0)), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3c

subroutine qrm_pdealloc_1z(a, info)

  complex(kind(1.d0)), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1z

subroutine qrm_pdealloc_2z(a, info)

  complex(kind(1.d0)), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2z

subroutine qrm_pdealloc_3z(a, info)

  complex(kind(1.d0)), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3z

subroutine qrm_pdealloc_1i(a, info)

  integer(kind=4), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1i

subroutine qrm_pdealloc_2i(a, info)

  integer(kind=4), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2i

subroutine qrm_pdealloc_3i(a, info)

  integer(kind=4), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3i

subroutine qrm_pdealloc_1i8(a, info)

  integer(kind=8), pointer, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_1i8

subroutine qrm_pdealloc_2i8(a, info)

  integer(kind=8), pointer, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_2i8

subroutine qrm_pdealloc_3i8(a, info)

  integer(kind=8), pointer, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(associated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_pdealloc_3i8

subroutine qrm_adealloc_1s(a, info)

  real(kind(1.e0)), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1s

subroutine qrm_adealloc_2s(a, info)

  real(kind(1.e0)), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2s

subroutine qrm_adealloc_3s(a, info)

  real(kind(1.e0)), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_s_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3s

subroutine qrm_adealloc_1d(a, info)

  real(kind(1.d0)), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1d

subroutine qrm_adealloc_2d(a, info)

  real(kind(1.d0)), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2d

subroutine qrm_adealloc_3d(a, info)

  real(kind(1.d0)), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_d_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3d

subroutine qrm_adealloc_1c(a, info)

  complex(kind(1.e0)), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1c

subroutine qrm_adealloc_2c(a, info)

  complex(kind(1.e0)), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2c

subroutine qrm_adealloc_3c(a, info)

  complex(kind(1.e0)), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_c_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3c

subroutine qrm_adealloc_1z(a, info)

  complex(kind(1.d0)), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1z

subroutine qrm_adealloc_2z(a, info)

  complex(kind(1.d0)), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2z

subroutine qrm_adealloc_3z(a, info)

  complex(kind(1.d0)), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_z_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3z

subroutine qrm_adealloc_1i(a, info)

  integer(kind=4), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1i

subroutine qrm_adealloc_2i(a, info)

  integer(kind=4), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2i

subroutine qrm_adealloc_3i(a, info)

  integer(kind=4), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3i

subroutine qrm_adealloc_1i8(a, info)

  integer(kind=8), allocatable, dimension(:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_1i8

subroutine qrm_adealloc_2i8(a, info)

  integer(kind=8), allocatable, dimension(:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_2i8

subroutine qrm_adealloc_3i8(a, info)

  integer(kind=8), allocatable, dimension(:,:,:) :: a
  integer, optional                       :: info

  integer(kind=qrm_mem_kind) :: s
  integer :: err

  err = 0
  
  if(allocated(a)) then
     s = size(a,kind=qrm_mem_kind)
     deallocate(a, stat=err)
  else
     return
  end if
  if(err .eq. 0) then
     call qrm_mem_upd(-s*qrm_sizeof_i8_)
  else
     err = 6
  end if

  if(present(info)) info = err
  return

end subroutine qrm_adealloc_3i8

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                     alloc routines                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine qrm_palloc_1s(a, m, info)

  real(kind(1.e0)), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1s

subroutine qrm_palloc_2s(a, m, n, info)

  real(kind(1.e0)), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2s

subroutine qrm_palloc_3s(a, m, n, k, info)

  real(kind(1.e0)), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3s

subroutine qrm_palloc_1d(a, m, info)

  real(kind(1.d0)), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1d

subroutine qrm_palloc_2d(a, m, n, info)

  real(kind(1.d0)), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2d

subroutine qrm_palloc_3d(a, m, n, k, info)

  real(kind(1.d0)), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3d

subroutine qrm_palloc_1c(a, m, info)

  complex(kind(1.e0)), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1c

subroutine qrm_palloc_2c(a, m, n, info)

  complex(kind(1.e0)), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2c

subroutine qrm_palloc_3c(a, m, n, k, info)

  complex(kind(1.e0)), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3c

subroutine qrm_palloc_1z(a, m, info)

  complex(kind(1.d0)), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1z

subroutine qrm_palloc_2z(a, m, n, info)

  complex(kind(1.d0)), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2z

subroutine qrm_palloc_3z(a, m, n, k, info)

  complex(kind(1.d0)), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3z

subroutine qrm_palloc_1i(a, m, info)

  integer(kind=4), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1i

subroutine qrm_palloc_2i(a, m, n, info)

  integer(kind=4), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2i

subroutine qrm_palloc_3i(a, m, n, k, info)

  integer(kind=4), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3i

subroutine qrm_palloc_1i8(a, m, info)

  integer(kind=8), pointer, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_1i8

subroutine qrm_palloc_2i8(a, m, n, info)

  integer(kind=8), pointer, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_2i8

subroutine qrm_palloc_3i8(a, m, n, k, info)

  integer(kind=8), pointer, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(associated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_palloc_3i8

subroutine qrm_aalloc_1s(a, m, info)

  real(kind(1.e0)), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1s

subroutine qrm_aalloc_2s(a, m, n, info)

  real(kind(1.e0)), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2s

subroutine qrm_aalloc_3s(a, m, n, k, info)

  real(kind(1.e0)), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_s_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3s

subroutine qrm_aalloc_1d(a, m, info)

  real(kind(1.d0)), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1d

subroutine qrm_aalloc_2d(a, m, n, info)

  real(kind(1.d0)), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2d

subroutine qrm_aalloc_3d(a, m, n, k, info)

  real(kind(1.d0)), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_d_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3d

subroutine qrm_aalloc_1c(a, m, info)

  complex(kind(1.e0)), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1c

subroutine qrm_aalloc_2c(a, m, n, info)

  complex(kind(1.e0)), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2c

subroutine qrm_aalloc_3c(a, m, n, k, info)

  complex(kind(1.e0)), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_c_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3c

subroutine qrm_aalloc_1z(a, m, info)

  complex(kind(1.d0)), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1z

subroutine qrm_aalloc_2z(a, m, n, info)

  complex(kind(1.d0)), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2z

subroutine qrm_aalloc_3z(a, m, n, k, info)

  complex(kind(1.d0)), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_z_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3z

subroutine qrm_aalloc_1i(a, m, info)

  integer(kind=4), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1i

subroutine qrm_aalloc_2i(a, m, n, info)

  integer(kind=4), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2i

subroutine qrm_aalloc_3i(a, m, n, k, info)

  integer(kind=4), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3i

subroutine qrm_aalloc_1i8(a, m, info)

  integer(kind=8), allocatable, dimension(:) :: a
  integer, intent(in)                     :: m
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if(m .le. 0) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_1i8

subroutine qrm_aalloc_2i8(a, m, n, info)

  integer(kind=8), allocatable, dimension(:,:) :: a
  integer, intent(in)                     :: m, n
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_2i8

subroutine qrm_aalloc_3i8(a, m, n, k, info)

  integer(kind=8), allocatable, dimension(:,:,:) :: a
  integer, intent(in)                     :: m, n, k
  integer, optional                       :: info

  integer :: err

  err = 0
  
  if((m .le. 0) .or. (n .le. 0) .or. (k .le. 0)) return

  if(allocated(a)) then
     err = 4
  else
     allocate(a(m, n, k), stat=err)
     if(err .eq. 0) then
        call qrm_mem_upd(size(a,kind=qrm_mem_kind)*qrm_sizeof_i8_)
     else
        err= 12
     end if
  end if

  if(present(info)) info = err
  return

end subroutine qrm_aalloc_3i8

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                     realloc routines                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine qrm_prealloc_1s(a, n, info, copy)

  real(kind(1.e0)), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  real(kind(1.e0)), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1s(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1s(a, tmp)
  else
     call qrm_pdealloc_1s(a)
  end if

  call qrm_palloc_1s(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1s(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1s

subroutine qrm_prealloc_1d(a, n, info, copy)

  real(kind(1.d0)), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  real(kind(1.d0)), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1d(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1d(a, tmp)
  else
     call qrm_pdealloc_1d(a)
  end if

  call qrm_palloc_1d(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1d(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1d

subroutine qrm_prealloc_1c(a, n, info, copy)

  complex(kind(1.e0)), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  complex(kind(1.e0)), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1c(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1c(a, tmp)
  else
     call qrm_pdealloc_1c(a)
  end if

  call qrm_palloc_1c(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1c(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1c

subroutine qrm_prealloc_1z(a, n, info, copy)

  complex(kind(1.d0)), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  complex(kind(1.d0)), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1z(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1z(a, tmp)
  else
     call qrm_pdealloc_1z(a)
  end if

  call qrm_palloc_1z(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1z(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1z

subroutine qrm_prealloc_1i(a, n, info, copy)

  integer(kind=4), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  integer(kind=4), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1i(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1i(a, tmp)
  else
     call qrm_pdealloc_1i(a)
  end if

  call qrm_palloc_1i(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1i(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1i

subroutine qrm_prealloc_1i8(a, n, info, copy)

  integer(kind=8), pointer, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  integer(kind=8), pointer, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.associated(a)) then
     call qrm_palloc_1i8(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_pmove_alloc_1i8(a, tmp)
  else
     call qrm_pdealloc_1i8(a)
  end if

  call qrm_palloc_1i8(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_pdealloc_1i8(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_prealloc_1i8

subroutine qrm_arealloc_1s(a, n, info, copy)

  real(kind(1.e0)), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  real(kind(1.e0)), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1s(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1s(a, tmp)
  else
     call qrm_adealloc_1s(a)
  end if

  call qrm_aalloc_1s(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1s(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1s

subroutine qrm_arealloc_1d(a, n, info, copy)

  real(kind(1.d0)), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  real(kind(1.d0)), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1d(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1d(a, tmp)
  else
     call qrm_adealloc_1d(a)
  end if

  call qrm_aalloc_1d(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1d(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1d

subroutine qrm_arealloc_1c(a, n, info, copy)

  complex(kind(1.e0)), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  complex(kind(1.e0)), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1c(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1c(a, tmp)
  else
     call qrm_adealloc_1c(a)
  end if

  call qrm_aalloc_1c(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1c(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1c

subroutine qrm_arealloc_1z(a, n, info, copy)

  complex(kind(1.d0)), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  complex(kind(1.d0)), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1z(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1z(a, tmp)
  else
     call qrm_adealloc_1z(a)
  end if

  call qrm_aalloc_1z(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1z(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1z

subroutine qrm_arealloc_1i(a, n, info, copy)

  integer(kind=4), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  integer(kind=4), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1i(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1i(a, tmp)
  else
     call qrm_adealloc_1i(a)
  end if

  call qrm_aalloc_1i(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1i(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1i

subroutine qrm_arealloc_1i8(a, n, info, copy)

  integer(kind=8), allocatable, dimension(:) :: a
  integer                                 :: n
  logical, optional                       :: copy
  integer, optional                       :: info

  integer                                 :: i, err
  logical                                 :: icopy
  integer(kind=8), allocatable, dimension(:) :: tmp

  ! a is not allocated. just allocate it and return
  if(.not.allocated(a)) then
     call qrm_aalloc_1i8(a, n, err)
     goto 9999
  else
     if(size(a,kind=qrm_mem_kind).ge.n) return
  end if

  if(present(copy)) then
     icopy=copy
  else
     icopy = .false.
  end if

  ! we need to reallocate
  if(icopy) then
     ! we must save a copy
     call qrm_amove_alloc_1i8(a, tmp)
  else
     call qrm_adealloc_1i8(a)
  end if

  call qrm_aalloc_1i8(a, n, err)
  if(err.ne.0) goto 9999

  ! check if copy is to be done
  if(icopy) then
     do i=1, size(a)
        a(i) = tmp(i)
     end do
     call qrm_adealloc_1i8(tmp, err)
  end if

9999 continue
  if(present(info)) info = err
  return
  
  return

end subroutine qrm_arealloc_1i8

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                     size routines                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function qrm_psize_1s(a)

  implicit none

  integer :: qrm_psize_1s
  real(kind(1.e0)), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1s = size(a)
  else
     qrm_psize_1s = 0
  end if

  return

end function qrm_psize_1s

function qrm_psize_2s(a)

  implicit none

  integer :: qrm_psize_2s
  real(kind(1.e0)), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2s = size(a)
  else
     qrm_psize_2s = 0
  end if

  return

end function qrm_psize_2s

function qrm_psize_3s(a)

  implicit none

  integer :: qrm_psize_3s
  real(kind(1.e0)), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3s = size(a)
  else
     qrm_psize_3s = 0
  end if

  return

end function qrm_psize_3s

function qrm_psize_1d(a)

  implicit none

  integer :: qrm_psize_1d
  real(kind(1.d0)), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1d = size(a)
  else
     qrm_psize_1d = 0
  end if

  return

end function qrm_psize_1d

function qrm_psize_2d(a)

  implicit none

  integer :: qrm_psize_2d
  real(kind(1.d0)), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2d = size(a)
  else
     qrm_psize_2d = 0
  end if

  return

end function qrm_psize_2d

function qrm_psize_3d(a)

  implicit none

  integer :: qrm_psize_3d
  real(kind(1.d0)), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3d = size(a)
  else
     qrm_psize_3d = 0
  end if

  return

end function qrm_psize_3d

function qrm_psize_1c(a)

  implicit none

  integer :: qrm_psize_1c
  complex(kind(1.e0)), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1c = size(a)
  else
     qrm_psize_1c = 0
  end if

  return

end function qrm_psize_1c

function qrm_psize_2c(a)

  implicit none

  integer :: qrm_psize_2c
  complex(kind(1.e0)), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2c = size(a)
  else
     qrm_psize_2c = 0
  end if

  return

end function qrm_psize_2c

function qrm_psize_3c(a)

  implicit none

  integer :: qrm_psize_3c
  complex(kind(1.e0)), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3c = size(a)
  else
     qrm_psize_3c = 0
  end if

  return

end function qrm_psize_3c

function qrm_psize_1z(a)

  implicit none

  integer :: qrm_psize_1z
  complex(kind(1.d0)), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1z = size(a)
  else
     qrm_psize_1z = 0
  end if

  return

end function qrm_psize_1z

function qrm_psize_2z(a)

  implicit none

  integer :: qrm_psize_2z
  complex(kind(1.d0)), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2z = size(a)
  else
     qrm_psize_2z = 0
  end if

  return

end function qrm_psize_2z

function qrm_psize_3z(a)

  implicit none

  integer :: qrm_psize_3z
  complex(kind(1.d0)), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3z = size(a)
  else
     qrm_psize_3z = 0
  end if

  return

end function qrm_psize_3z

function qrm_psize_1i(a)

  implicit none

  integer :: qrm_psize_1i
  integer(kind=4), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1i = size(a)
  else
     qrm_psize_1i = 0
  end if

  return

end function qrm_psize_1i

function qrm_psize_2i(a)

  implicit none

  integer :: qrm_psize_2i
  integer(kind=4), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2i = size(a)
  else
     qrm_psize_2i = 0
  end if

  return

end function qrm_psize_2i

function qrm_psize_3i(a)

  implicit none

  integer :: qrm_psize_3i
  integer(kind=4), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3i = size(a)
  else
     qrm_psize_3i = 0
  end if

  return

end function qrm_psize_3i

function qrm_psize_1i8(a)

  implicit none

  integer :: qrm_psize_1i8
  integer(kind=8), pointer, dimension(:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_1i8 = size(a)
  else
     qrm_psize_1i8 = 0
  end if

  return

end function qrm_psize_1i8

function qrm_psize_2i8(a)

  implicit none

  integer :: qrm_psize_2i8
  integer(kind=8), pointer, dimension(:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_2i8 = size(a)
  else
     qrm_psize_2i8 = 0
  end if

  return

end function qrm_psize_2i8

function qrm_psize_3i8(a)

  implicit none

  integer :: qrm_psize_3i8
  integer(kind=8), pointer, dimension(:,:,:) :: a

  if(associated(a)) then
     ! a is allocated    
     qrm_psize_3i8 = size(a)
  else
     qrm_psize_3i8 = 0
  end if

  return

end function qrm_psize_3i8

function qrm_asize_1s(a)

  implicit none

  integer :: qrm_asize_1s
  real(kind(1.e0)), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1s = size(a)
  else
     qrm_asize_1s = 0
  end if

  return

end function qrm_asize_1s

function qrm_asize_2s(a)

  implicit none

  integer :: qrm_asize_2s
  real(kind(1.e0)), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2s = size(a)
  else
     qrm_asize_2s = 0
  end if

  return

end function qrm_asize_2s

function qrm_asize_3s(a)

  implicit none

  integer :: qrm_asize_3s
  real(kind(1.e0)), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3s = size(a)
  else
     qrm_asize_3s = 0
  end if

  return

end function qrm_asize_3s

function qrm_asize_1d(a)

  implicit none

  integer :: qrm_asize_1d
  real(kind(1.d0)), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1d = size(a)
  else
     qrm_asize_1d = 0
  end if

  return

end function qrm_asize_1d

function qrm_asize_2d(a)

  implicit none

  integer :: qrm_asize_2d
  real(kind(1.d0)), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2d = size(a)
  else
     qrm_asize_2d = 0
  end if

  return

end function qrm_asize_2d

function qrm_asize_3d(a)

  implicit none

  integer :: qrm_asize_3d
  real(kind(1.d0)), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3d = size(a)
  else
     qrm_asize_3d = 0
  end if

  return

end function qrm_asize_3d

function qrm_asize_1c(a)

  implicit none

  integer :: qrm_asize_1c
  complex(kind(1.e0)), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1c = size(a)
  else
     qrm_asize_1c = 0
  end if

  return

end function qrm_asize_1c

function qrm_asize_2c(a)

  implicit none

  integer :: qrm_asize_2c
  complex(kind(1.e0)), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2c = size(a)
  else
     qrm_asize_2c = 0
  end if

  return

end function qrm_asize_2c

function qrm_asize_3c(a)

  implicit none

  integer :: qrm_asize_3c
  complex(kind(1.e0)), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3c = size(a)
  else
     qrm_asize_3c = 0
  end if

  return

end function qrm_asize_3c

function qrm_asize_1z(a)

  implicit none

  integer :: qrm_asize_1z
  complex(kind(1.d0)), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1z = size(a)
  else
     qrm_asize_1z = 0
  end if

  return

end function qrm_asize_1z

function qrm_asize_2z(a)

  implicit none

  integer :: qrm_asize_2z
  complex(kind(1.d0)), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2z = size(a)
  else
     qrm_asize_2z = 0
  end if

  return

end function qrm_asize_2z

function qrm_asize_3z(a)

  implicit none

  integer :: qrm_asize_3z
  complex(kind(1.d0)), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3z = size(a)
  else
     qrm_asize_3z = 0
  end if

  return

end function qrm_asize_3z

function qrm_asize_1i(a)

  implicit none

  integer :: qrm_asize_1i
  integer(kind=4), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1i = size(a)
  else
     qrm_asize_1i = 0
  end if

  return

end function qrm_asize_1i

function qrm_asize_2i(a)

  implicit none

  integer :: qrm_asize_2i
  integer(kind=4), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2i = size(a)
  else
     qrm_asize_2i = 0
  end if

  return

end function qrm_asize_2i

function qrm_asize_3i(a)

  implicit none

  integer :: qrm_asize_3i
  integer(kind=4), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3i = size(a)
  else
     qrm_asize_3i = 0
  end if

  return

end function qrm_asize_3i

function qrm_asize_1i8(a)

  implicit none

  integer :: qrm_asize_1i8
  integer(kind=8), allocatable, dimension(:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_1i8 = size(a)
  else
     qrm_asize_1i8 = 0
  end if

  return

end function qrm_asize_1i8

function qrm_asize_2i8(a)

  implicit none

  integer :: qrm_asize_2i8
  integer(kind=8), allocatable, dimension(:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_2i8 = size(a)
  else
     qrm_asize_2i8 = 0
  end if

  return

end function qrm_asize_2i8

function qrm_asize_3i8(a)

  implicit none

  integer :: qrm_asize_3i8
  integer(kind=8), allocatable, dimension(:,:,:) :: a

  if(allocated(a)) then
     ! a is allocated    
     qrm_asize_3i8 = size(a)
  else
     qrm_asize_3i8 = 0
  end if

  return

end function qrm_asize_3i8


end module qrm_mem_mod